#!/usr/bin/perl
# Netsaint plugin
# It is called from inetd like 
#
# finger  stream  tcp nowait root  /usr/gnu/netsaint/libexec/netclient.pl


# Change path to proper location

$CF="/usr/gnu/netsaint/etc/clients.cfg";

# --------------------------------------------

$BOUND_CHECKING = 255;


($param) = @ARGV;

if (!$param)
{
    $param = <>;
    $param =~ s/[\r\n]//gi;
}

if (length($param) > $BOUND_CHECKING)
{
    $param = substr $param,0,$BOUND_CHECKING;
}


if ( $param =~ /^(.+?),(.*)/ ) {
 $command=$1;
 $param=$2;
 # Now, we'll find command
 open(CF,$CF) or die("Cannot open $CF");
 while(<CF>) {
   if ( $_ =~ /^command\[$command\]=(.*)/ ) {
     $command=$1;
     &param;
     open(COMMAND,"$command|") or die("Command $command is bad");
     $answer=<COMMAND>;
     close(COMMAND); 
     $ret=$?>>8;
     print "ANSWER: $answer";
     if ( $ret == 0 )   { print "STATE: OK\n"      };
     if ( $ret == 1 ) { print "STATE: WARNING\n" };
     if ( $ret == 2 ) { print "STATE: CRITICAL\n"      };
     if ( $ret != 0 && $ret != 1 && $ret != 2 ) { print "STATE: UNKNOWN\n" };
   } 
 }
 close(CF);
}
else {
 exec("finger $param");
}

sub param()
{ # Substitute macro
 $command =~ s/\$ARG1\$/$param/gi ;
}

