#!/usr/bin/perl

$service=@ARGV[0];
$host=@ARGV[1];

$service.="," if ( $service !~ /,/ );

my %ERRORS = ('UNKNOWN', '-1',
              'OK', '0',
	      'WARNING', '1',
	      'CRITICAL', '2');

open(MESSAGE,"finger $service\@$host|") or die("I cannot open finger");
	
while(<MESSAGE>) {
/ANSWER:/ && do { print substr($_,8); };
/STATE:/  && do {
		  close(MESSAGE);
		  chomp;
		  exit $ERRORS{substr($_,7)};
		};
}					

close(MESSAGE);
exit $ERRORS{UNKNOWN};

